VirtualBox

source: vbox/trunk/configure@ 3481

Last change on this file since 3481 was 3328, checked in by vboxsync, 17 years ago

configure: fixed gcc version check (deny gcc-4.0); make echo work on all environments

  • Property svn:executable set to *
File size: 31.0 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 innotek GmbH
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16# If you received this file as part of a commercial VirtualBox
17# distribution, then only the terms of your commercial VirtualBox
18# license agreement apply instead of the previous paragraph.
19#
20
21LC_ALL=C
22export LC_ALL
23
24#
25# Defaults
26#
27OSE=1
28WITH_XPCOM=1
29WITH_LIBIDL=1
30WITH_QT=1
31WITH_SDL_TTF=1
32WITH_HAL=1
33CC="gcc"
34CXX="g++"
35BCC="bcc"
36YASM="yasm"
37IASL="iasl"
38AS86="as86"
39XSLTPROC="xsltproc"
40GENISOIMAGE="genisoimage"
41MKISOFS="mkisofs"
42INCXALAN=""
43LIBXALAN="-lxalan-c"
44INCXERCES=""
45LIBXERCES="-lxerces-c"
46LIBCRYPTO="-lcrypto"
47LIBPTHREAD="-lpthread"
48LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -lXext -lX11"
49LIBXCURSOR="-lXcursor"
50INCZ=""
51LIBZ="-lz"
52INCPNG=""
53LIBPNG="-lpng"
54CFLAGSHAL="-I/usr/include/hal -I/usr/include/dbus-1.0 -I/usr/lib/dbus-1.0/include"
55LIBPATHHAL=""
56LIBHAL="-lhal -ldbus-1"
57QTDIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3 /usr/lib64/qt-3.3 /usr/X11R6"
58KBUILDDIR="`cd $(dirname $0); pwd`/kBuild"
59DEVDIR="`cd $(dirname $0); pwd`/tools"
60if [ -d "/lib/modules/`uname -r`/build" ]; then
61 LINUX="/lib/modules/`uname -r`/build"
62else
63 LINUX="/usr/src/linux"
64fi
65KCHMVIEWER="kchmviewer"
66LOG="configure.log"
67CNF="AutoConfig.kmk"
68ENV="env.sh"
69BUILD_TYPE="release"
70# the restricting tool is ar (mri mode).
71INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
72
73if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
74 echo "Error: VBox base path contains invalid characters!"
75 exit 1
76fi
77
78cleanup()
79{
80 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
81}
82
83fail()
84{
85 if [ -z "$nofatal" -o "x$1" != "x" ]; then
86 cleanup
87 rm -f $ENV
88 exit 1
89 fi
90}
91
92log_success()
93{
94 if [ -n "$1" ]; then echo -n "$1, "; fi
95 echo "OK."
96 echo "$1" >> $LOG
97 echo >> $LOG
98 echo >> $LOG
99}
100
101log_failure()
102{
103 echo
104 echo " ** $1!"
105 echo "** $1!" >> $LOG
106 echo >> $LOG
107}
108
109cnf_append()
110{
111 printf "%-30s := %s\n" "$1" "$2" >> $CNF
112}
113
114strip_l()
115{
116 echo "$1"|sed 's|-l\([^ ]\+\)|\1|g; s|-[^l]\([^ ]\+\)||g; s|^ ||; s| *$||g'
117}
118
119strip_L()
120{
121 echo "$1"|sed 's|-L\([^ ]\+\)|\1|g; s|-[^L]\([^ ]\+\)||g; s|^ ||; s| *$||g'
122}
123
124strip_I()
125{
126 echo "$1"|sed 's|-I\([^ ]\+\)|\1|g; s|-[^I]\([^ ]\+\)||g; s|^ ||; s| *$||g'
127}
128
129# Wrapper for ancient /usr/bin/which on darwin that always returns 0
130which_wrapper()
131{
132 if [ -z "$have_ancient_which" ]; then
133 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
134 have_ancient_which="yes"
135 else
136 have_ancient_which="no"
137 fi
138 fi
139 if [ "$have_ancient_which" = "yes" ]; then
140 local retval=`which $* 2>/dev/null`
141 echo "$retval"
142 test -n "$retval" -a -e "$retval"
143 else
144 which $* 2> /dev/null
145 fi
146}
147
148check_avail()
149{
150 if [ -z "$1" ]; then
151 log_failure "$2 is empty"
152 fail $3
153 return 1
154 elif which_wrapper $1 > /dev/null; then
155 return 0
156 else
157 log_failure "$1 (variable $2) not found"
158 fail $3
159 return 1
160 fi
161}
162
163# Prepare a test
164test_header()
165{
166 echo "***** Checking $1 *****" >> $LOG
167 echo -n "Checking for $1: "
168}
169
170# Compile a test
171test_compile()
172{
173 echo "compiling the following source file:" >> $LOG
174 cat .tmp_src.cc >> $LOG
175 echo "using the following command line:" >> $LOG
176 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
177 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
178 if [ $? -ne 0 ]; then
179 if [ -z "$4" ]; then
180 echo
181 echo " $2 not found at $1 or $3 headers not found"
182 echo " Check the file $LOG for detailed error information."
183 fail
184 else
185 echo "not found."
186 echo >> $LOG
187 echo >> $LOG
188 fi
189 return 1
190 fi
191 return 0
192}
193
194# Execute a compiled test binary
195test_execute()
196{
197 echo "executing the binary" >> $LOG
198 ./.tmp_out > .test_execute.log
199 rc=$?
200 cat .test_execute.log | tee -a $LOG
201 if [ $rc -ne 0 ]; then
202 fail $1
203 return 1
204 fi
205 echo >> $LOG
206 echo >> $LOG
207 return 0
208}
209
210#
211# Check for OS, MACHINE, CPU
212#
213check_environment()
214{
215 test_header environment
216 CPU=`uname -m`
217 case "$CPU" in
218 i[3456789]86|x86)
219 MACHINE='x86'
220 LIB='lib'
221 ;;
222 x86_64|amd64)
223 MACHINE='amd64'
224 CPU='k8'
225 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
226 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
227 LIB='lib64'
228 ;;
229 *)
230 log_failure "Cannot determine system"
231 exit 1
232 ;;
233 esac
234 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr 'A-Z' 'a-z'`
235 case "$OS" in
236 linux)
237 ;;
238 darwin)
239 ;;
240 freebsd)
241 ;;
242 *)
243 log_failure "Cannot determine OS"
244 exit 1
245 ;;
246 esac
247 DEVDIR_BIN="$DEVDIR/$OS.$MACHINE/bin"
248 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$MACHINE"
249 log_success "Determined $OS.$MACHINE"
250
251 # Automatically disable XPCOM on darwin.
252 if [ "$OS" = "darwin" -a $WITH_XPCOM -eq 1 ]; then
253 WITH_XPCOM=0
254 WITH_LIBIDL=0
255 WITH_QT=0
256 echo "Disabling checks for XPCOM related components."
257 fi
258}
259
260#
261# Check for gcc with version >= 3.2.
262# We depend on a working gcc, if we fail terminate in every case.
263#
264check_gcc()
265{
266 test_header gcc
267 if check_avail "$CC" CC really; then
268 cc_ver=`$CC -dumpversion`
269 if check_avail "$CXX" CXX really; then
270 cxx_ver=`$CXX -dumpversion`
271 cc_maj=`echo $cc_ver|cut -d. -f1`
272 cc_min=`echo $cc_ver|cut -d. -f2`
273 if [ "x$cc_ver" != "x$cxx_ver" ]; then
274 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
275 fail really
276 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 ]; then
277 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
278 fail really
279 elif [ $cc_maj -gt 3 ]; then
280 log_success "found version $cc_ver"
281 elif [ $cc_maj -lt 3 -o $cc_min -lt 2 ]; then
282 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with x>0"
283 fail really
284 else
285 log_success "found version $cc_ver"
286 fi
287 if [ "$CC" != "gcc" ]; then
288 cnf_append "TOOL_GCC3_CC" "$CC"
289 cnf_append "TOOL_GCC3_AS" "$CC"
290 cnf_append "TOOL_GXX3_CC" "$CC"
291 cnf_append "TOOL_GXX3_AS" "$CC"
292 fi
293 if [ "$CXX" != "g++" ]; then
294 cnf_append "TOOL_GCC3_CXX" "$CXX"
295 cnf_append "TOOL_GCC3_LD" "$CXX"
296 cnf_append "TOOL_GXX3_CXX" "$CXX"
297 cnf_append "TOOL_GXX3_LD" "$CXX"
298 fi
299 fi
300 fi
301}
302
303#
304# Check for the bcc compiler, needed for compiling the BIOS
305#
306check_bcc()
307{
308 test_header bcc
309 if check_avail "$BCC" BCC; then
310 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
311 if [ $? -ne 0 ]; then
312 log_failure "not found"
313 fail
314 else
315 echo "compiling the following source file:" >> $LOG
316 cat > .tmp_src.c << EOF
317int foo(a)
318 int a;
319{
320 return 0;
321}
322EOF
323 cat .tmp_src.c >> $LOG
324 local bcc_path=`which_wrapper $BCC`
325 local bcc_dir="`dirname $bcc_path`/"
326 echo "using the following command line:" >> $LOG
327 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
328 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
329 if [ $? -ne 0 ]; then
330 log_failure "not found"
331 fail
332 else
333 log_success "found version $bcc_ver"
334 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
335 fi
336 fi
337 fi
338}
339
340#
341# Check for the as86 assembler, needed for compiling the BIOS
342#
343check_as86()
344{
345 test_header as86
346 if check_avail "$AS86" AS86; then
347 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
348 if [ $? -ne 0 ]; then
349 log_failure "not found"
350 fail
351 else
352 log_success "found version $as86_ver"
353 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
354 fi
355 fi
356}
357
358#
359# Check for yasm, needed to compile assembler files
360#
361check_yasm()
362{
363 test_header yasm
364 if check_avail "$YASM" YASM; then
365 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
366 if [ $? -ne 0 ]; then
367 log_failure "not found"
368 fail
369 else
370 yasm_maj=`echo $yasm_ver|cut -d. -f1`
371 yasm_min=`echo $yasm_ver|cut -d. -f2`
372 yasm_rev=`echo $yasm_ver|cut -d. -f3`
373 yasm_ver_mul=$(($yasm_maj*10000+$yasm_min*100+$yasm_rev))
374 if [ $yasm_ver_mul -lt 501 ]; then
375 log_failure "found version $yasm_ver, expected at least 0.5.1"
376 fail
377 else
378 log_success "found version $yasm_ver"
379 fi
380 fi
381 fi
382}
383
384#
385# Check for the iasl ACPI compiler, needed to compile vbox.dsl
386#
387check_iasl()
388{
389 test_header iasl
390 if check_avail "$IASL" IASL; then
391 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
392 if [ $? -ne 0 ]; then
393 log_failure "not found"
394 fail
395 else
396 log_success "found version $iasl_ver"
397 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
398 fi
399 fi
400}
401
402#
403# Check for xsltproc, needed by Main
404#
405check_xsltproc()
406{
407 test_header xslt
408 if check_avail "$XSLTPROC" XSLTPROC; then
409 xsltproc_ver=`$XSLTPROC --version`
410 if [ $? -ne 0 ]; then
411 log_failure "not found"
412 fail
413 else
414 log_success "found"
415 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
416 fi
417 fi
418}
419
420#
421# Check for mkisofs, needed to build the CDROM image containing the additions
422#
423check_mkisofs()
424{
425 test_header mkisofs
426 if which_wrapper $GENISOIMAGE > /dev/null; then
427 mkisofs_ver=`$GENISOIMAGE --version`
428 if [ $? -ne 0 ]; then
429 log_failure "not found"
430 fail
431 else
432 log_success "found $mkisofs_ver"
433 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
434 fi
435 elif check_avail "$MKISOFS" MKISOFS; then
436 mkisofs_ver=`$MKISOFS --version`
437 if [ $? -ne 0 ]; then
438 log_failure "not found"
439 fail
440 else
441 log_success "found $mkisofs_ver"
442 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
443 fi
444 fi
445}
446
447#
448# Check for xalan, needed by VBoxXML
449#
450check_xalan()
451{
452 if [ -n "$LIBXALAN" ]; then
453 test_header xalan
454 cat > .tmp_src.cc << EOF
455#include <cstdio>
456#include <xalanc/Include/XalanVersion.hpp>
457extern "C" int main(void)
458{
459 printf("found version %d.%d.%d",
460 XALAN_VERSION_MAJOR, XALAN_VERSION_MINOR, XALAN_VERSION_REVISION);
461#if _XALAN_VERSION >= 10800
462 printf(", OK.\n");
463 return 0;
464#else
465 printf(", expected version 1.8.0 or higher\n");
466 return 1;
467#endif
468}
469EOF
470 if test_compile "$LIBXALAN $LIBPTHREAD ${INCXALAN:+-I$INCXALAN}" xalan xalanc; then
471 if test_execute; then
472 cnf_append "SDK_VBOX_XALAN_LIBS" "`strip_l "$LIBXALAN"`"
473 cnf_append "SDK_VBOX_XALAN_INCS" "$INCXALAN"
474 fi
475 fi
476 else
477 echo "Building xalan from shipped sources."
478 echo "Building xalan from shipped sources." >> $LOG
479 echo >> $LOG
480 echo >> $LOG
481 fi
482}
483
484#
485# Check for xerces, needed by VBoxXML
486#
487check_xerces()
488{
489 if [ -n "$LIBXERCES" ]; then
490 test_header xerces
491 cat > .tmp_src.cc << EOF
492#include <cstdio>
493#include <xercesc/util/XercesVersion.hpp>
494extern "C" int main(void)
495{
496 printf("found version %d.%d.%d",
497 XERCES_VERSION_MAJOR, XERCES_VERSION_MINOR, XERCES_VERSION_REVISION);
498#if _XERCES_VERSION >= 20500
499 printf(", OK.\n");
500 return 0;
501#else
502 printf(", expected version 2.5.0 or higher");
503 return 1;
504#endif
505}
506EOF
507 if test_compile "$LIBXERCES $LIBPTHREAD ${INCXERCES:+-I$INCXERCES}" xerces xercesc; then
508 if test_execute; then
509 cnf_append "SDK_VBOX_XERCES_LIBS" "`strip_l "$LIBXERCES"`"
510 cnf_append "SDK_VBOX_XERCES_INCS" "$INCXERCES"
511 fi
512 fi
513 else
514 echo "Building xerces from shipped sources."
515 echo "Building xerces from shipped sources." >> $LOG
516 echo >> $LOG
517 echo >> $LOG
518 fi
519}
520
521#
522# Check for libIDL, needed by xpcom
523#
524check_libidl()
525{
526 test_header libIDL
527
528 if which_wrapper libIDL-config-2 > /dev/null; then
529 libidl_ver=`libIDL-config-2 --version`
530 if [ $? -ne 0 ]; then
531 log_failure "not found"
532 fail
533 else
534 log_success "found version $libidl_ver"
535 cnf_append "VBOX_LIBIDL_CONFIG" \
536 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
537 fi
538 elif check_avail "libIDL-config" libIDL-config; then
539 libidl_ver=`libIDL-config --version`
540 if [ $? -ne 0 ]; then
541 log_failure "not found"
542 fail
543 else
544 log_success "found version $libidl_ver"
545 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
546 fi
547 fi
548}
549
550#
551# Check for openssl, needed for RDP
552#
553check_ssl()
554{
555 test_header ssl
556 cat > .tmp_src.cc << EOF
557#include <cstdio>
558#include <openssl/opensslv.h>
559extern "C" int main(void)
560{
561 printf("found version %s", OPENSSL_VERSION_TEXT);
562#if OPENSSL_VERSION_NUMBER >= 0x0090700
563 printf(", OK.\n");
564 return 0;
565#else
566 printf(", expected version 0.9.7 or higher\n");
567 return 1;
568#endif
569}
570EOF
571 if test_compile $LIBCRYPTO libcrypto openssl; then
572 if test_execute nofatal; then
573 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
574 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
575 fi
576 fi
577}
578
579#
580# Check for pthread, needed by VBoxSVC, frontends, ...
581#
582check_pthread()
583{
584 test_header pthread
585 cat > .tmp_src.cc << EOF
586#include <cstdio>
587#include <pthread.h>
588extern "C" int main(void)
589{
590 pthread_mutex_t mutex;
591 if (pthread_mutex_init(&mutex, NULL)) {
592 printf("pthread_mutex_init() failed\n");
593 return 1;
594 }
595 if (pthread_mutex_lock(&mutex)) {
596 printf("pthread_mutex_lock() failed\n");
597 return 1;
598 }
599 if (pthread_mutex_unlock(&mutex)) {
600 printf("pthread_mutex_unlock() failed\n");
601 return 1;
602 }
603 printf("found, OK.\n");
604}
605EOF
606 if test_compile $LIBPTHREAD pthread pthread; then
607 if test_execute; then
608 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
609 fi
610 fi
611}
612
613#
614# Check for zlib, needed by VBoxSVC, Runtime, ...
615#
616check_z()
617{
618 test_header zlib
619 cat > .tmp_src.cc << EOF
620#include <cstdio>
621#include <zlib.h>
622extern "C" int main(void)
623{
624 printf("found version %s", ZLIB_VERSION);
625#if ZLIB_VERNUM >= 0x1210
626 printf(", OK.\n");
627 return 0;
628#else
629 printf(", expected version 1.2.1 or higher\n");
630 return 1;
631#endif
632}
633EOF
634 if test_compile "$LIBZ ${INCZ:+-I$INCZ}" zlib zlib; then
635 if test_execute; then
636 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
637 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
638 fi
639 fi
640}
641
642#
643# Check for libpng, needed by kchmviewer
644#
645check_png()
646{
647 test_header libpng
648 cat > .tmp_src.cc << EOF
649#include <cstdio>
650#include <png.h>
651extern "C" int main(void)
652{
653 printf("found version %s", PNG_LIBPNG_VER_STRING);
654#if PNG_LIBPNG_VER >= 10205
655 printf(", OK.\n");
656 return 0;
657#else
658 printf(", expected version 1.2.5 or higher\n");
659 return 1;
660#endif
661}
662EOF
663# if test_compile "$LIBPNG ${INCPNG:+-I$INCPNG}" libpng libpng nofatal; then
664 if test_compile "$LIBPNG ${INCPNG:+-I$INCPNG}" libpng libpng; then
665# if test_execute nofatal; then
666 if test_execute; then
667 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
668 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
669 fi
670 fi
671}
672
673#
674# Check for pam, needed by VRDPAuth
675# Version 79 was introduced in 9/2005, do we support older versions?
676# Debian/sarge uses 76
677# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
678#
679check_pam()
680{
681 test_header pam
682 cat > .tmp_src.cc << EOF
683#include <cstdio>
684#include <security/pam_appl.h>
685extern "C" int main(void)
686{
687 printf("found version %d", __LIBPAM_VERSION);
688 if (__LIBPAM_VERSION >= 76)
689 {
690 printf(", OK.\n");
691 return 0;
692 }
693 else
694 {
695 printf(", expected version 76 or higher\n");
696 return 1;
697 }
698}
699EOF
700 if test_compile "-lpam" pam pam nofatal; then
701 if test_execute nofatal; then
702 return 0;
703 fi
704 fi
705 test_header linux_pam
706 cat > .tmp_src.cc << EOF
707#include <cstdio>
708#include <security/pam_appl.h>
709extern "C" int main(void)
710{
711 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
712 if (__LINUX_PAM__ >= 1)
713 {
714 printf(", OK.\n");
715 return 0;
716 }
717 else
718 {
719 printf(", expected version 1.0 or higher\n");
720 return 1;
721 }
722}
723EOF
724 if test_compile "-lpam" pam pam; then
725 test_execute
726 fi
727}
728
729
730#
731# Check for the SDL library, needed by VBoxSDL and VirtualBox
732# We depend at least on version 1.2.7
733#
734check_sdl()
735{
736 test_header SDL
737 if which_wrapper sdl-config > /dev/null; then
738 FLGSDL=`sdl-config --cflags`
739 INCSDL=`strip_I "$FLGSDL"`
740 LIBSDL=`sdl-config --libs`
741 LIBSDLMAIN="-lSDLmain"
742 cat > .tmp_src.cc << EOF
743#include <cstdio>
744#include <SDL/SDL.h>
745#include <SDL/SDL_main.h>
746extern "C" int main(void)
747{
748 printf("found version %d.%d.%d",
749 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
750#if SDL_VERSION_ATLEAST(1,2,7)
751 printf(", OK.\n");
752 return 0;
753#else
754 printf(", expected version 1.2.7 or higher\n");
755 return 1;
756#endif
757}
758EOF
759 if test_compile "$LIBSDL $LIBSDLMAIN ${INCSDL:+-I$INCSDL}" SDL SDL; then
760 if test_execute; then
761 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
762 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
763 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
764 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
765 fi
766 fi
767 else
768 log_failure "not found"
769 fi
770}
771
772#
773# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
774#
775check_sdl_ttf()
776{
777 test_header SDL_ttf
778 cat > .tmp_src.cc << EOF
779#include <cstdio>
780#include <SDL/SDL_ttf.h>
781#ifndef SDL_TTF_MAJOR_VERSION
782#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
783#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
784#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
785#endif
786extern "C" int main(void)
787{
788 printf("found version %d.%d.%d",
789 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
790#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
791 printf(", OK.\n");
792 return 0;
793#else
794 printf(", expected version 2.0.6 or higher\n");
795 return 1;
796#endif
797}
798EOF
799 if test_compile "-lSDL_ttf" SDL_ttf SDL_ttf; then
800 test_execute
801 fi
802}
803
804#
805# Check for libasound, needed by the ALSA audio backend
806#
807check_alsa()
808{
809 test_header ALSA
810 cat > .tmp_src.cc << EOF
811#include <alsa/asoundlib.h>
812extern "C" int main(void)
813{
814 printf("found version %d.%d.%d",
815 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
816#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
817 printf(", OK.\n");
818 return 0;
819#else
820 printf(", expected version 1.0.6 or higher\n");
821 return 1;
822#endif
823}
824EOF
825 if test_compile "-lasound" asound asound; then
826 test_execute
827 fi
828}
829
830#
831# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
832#
833check_xcursor()
834{
835 test_header Xcursor
836 cat > .tmp_src.cc << EOF
837#include <cstdio>
838#include <X11/Xlib.h>
839#include <X11/Xcursor/Xcursor.h>
840extern "C" int main(void)
841{
842 XcursorImage *cursor = XcursorImageCreate (10, 10);
843 XcursorImageDestroy(cursor);
844 return 0;
845}
846EOF
847 if test_compile "$LIBX11 $LIBXCURSOR" Xcursor Xcursor; then
848 log_success "found"
849 cnf_append "LIB_XCURSOR" "`strip_l "$LIBXCURSOR"`"
850 fi
851}
852
853#
854# Check for the X libraries (Xext, X11)
855#
856check_x()
857{
858 test_header "X libraries"
859 cat > .tmp_src.cc << EOF
860#include <cstdio>
861#include <X11/Xlib.h>
862extern "C" int main(void)
863{
864 Display *dpy;
865 int scrn_num;
866 Screen *scrn;
867 Window win;
868
869 dpy = XOpenDisplay(NULL);
870 scrn_num = DefaultScreen(dpy);
871 scrn = ScreenOfDisplay(dpy, scrn_num);
872 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
873 0, 16, InputOutput, CopyFromParent, 0, NULL);
874 XDestroyWindow(dpy, win);
875}
876EOF
877 if test_compile "$LIBX11" Xlibs Xlibs; then
878 log_success "found"
879 fi
880}
881
882#
883# Check for the QT library, needed by VirtualBox
884#
885check_qt()
886{
887 test_header Qt
888 cat > .tmp_src.cc << EOF
889#include <cstdio>
890#include <qglobal.h>
891extern "C" int main(void)
892{
893 printf("found version %s", QT_VERSION_STR);
894#if QT_VERSION >= 0x030305
895 printf(", OK.\n");
896 return 0;
897#elif QT_VERSION >= 0x030300
898 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
899#else
900 printf(", expected version 3.3.0 or higher\n");
901 return 1;
902#endif
903}
904EOF
905 found_qt=0
906 libs="lib"
907 [ "$LIB" = "lib64" ] && libs="$libs lib64"
908 for q in $QTDIR; do
909 for l in $libs; do
910 echo "compiling the following source file:" >> $LOG
911 cat .tmp_src.cc >> $LOG
912 echo "using the following command line:" >> $LOG
913 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt" >> $LOG
914
915 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt >> $LOG 2>&1
916 if [ $? -eq 0 ]; then
917 if test_execute; then
918 cnf_append "QTDIR" "`cd $q ; pwd`"
919 found_qt=1
920 break
921 fi
922 fi
923 done
924 if [ $found_qt -eq 1 ]; then
925 break
926 fi
927 done
928 if [ $found_qt -ne 1 ]; then
929 echo
930 echo " Qt not found at \"$QTDIR\" or Qt headers not found"
931 echo " Check the file $LOG for detailed error information."
932 fail
933 return 1
934 fi
935 test_header "Qt devtools"
936 if check_avail "$q/bin/moc" QTDIR/bin; then
937 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
938 if [ $? -ne 0 ]; then
939 log_failure "not found"
940 fail
941 else
942 log_success "found version $moc_ver"
943 fi
944 fi
945}
946
947#
948# Check for Linux sources
949#
950check_linux()
951{
952 test_header "Linux kernel sources"
953 cat > .tmp_src.c << EOF
954#include <linux/version.h>
955int printf(const char *format, ...);
956int main(void)
957{
958 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
959 (LINUX_VERSION_CODE % 65536) / 256,
960 LINUX_VERSION_CODE % 256);
961#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
962 printf(", OK.\n");
963 return 0;
964#else
965 printf(", expected version 2.4.0 or higher\n");
966 return 1;
967#endif
968}
969EOF
970 echo "compiling the following source file:" >> $LOG
971 cat .tmp_src.c >> $LOG
972 echo "using the following command line:" >> $LOG
973 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
974 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
975 if [ $? -ne 0 ]; then
976 echo
977 echo " Linux kernel headers not found at $LINUX"
978 echo " Check the file $LOG for detailed error information."
979 fail
980 else
981 if test_execute; then
982 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
983 fi
984 fi
985}
986
987#
988# Check for kchmviewer, needed to display the online help
989#
990check_kchmviewer()
991{
992 test_header kchmviewer
993 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
994 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
995 if [ $? -ne 0 ]; then
996 log_failure "not found"
997 fail
998 else
999 log_success "found version $kchmviewer_ver"
1000 fi
1001 fi
1002}
1003
1004#
1005# Check for the kBuild tools, we don't support GNU make
1006#
1007check_kbuild()
1008{
1009 test_header kBuild
1010 if check_avail "$KBUILDDIR_BIN/kmk" KBUILDDIR really; then
1011 log_success "found"
1012 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
1013 echo "export BUILD_PLATFORM_ARCH=\"$MACHINE\"" >> $ENV
1014 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
1015 echo "export BUILD_TARGET_ARCH=\"$MACHINE\"" >> $ENV
1016 echo "export BUILD_TARGET_CPU=\"$CPU\"" >> $ENV
1017 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
1018 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1019 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1020 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1021 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1022 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1023 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1024 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1025 echo "export PATH" >> $ENV
1026 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1027 fi
1028}
1029
1030
1031#
1032# Check for compiler.h
1033# Some Linux distributions include "compiler.h" in their libc linux
1034# headers package, some don't. Most don't need it, building might (!)
1035# not succeed on openSUSE without it.
1036#
1037# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1038#
1039check_compiler_h()
1040{
1041 test_header compiler.h
1042 if ! test -f "/usr/include/linux/compiler.h"; then
1043 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1044 log_success "compiler.h not found"
1045 else
1046 log_success "compiler.h found"
1047 fi
1048}
1049
1050
1051#
1052# Check for the libhal library for obtaining hardware information on Linux
1053#
1054check_libhal()
1055{
1056 test_header libhal
1057 pc_cflagshal=`pkg-config hal --cflags 2>/dev/null`
1058 pc_libhal=`pkg-config hal --libs-only-l 2>/dev/null`
1059 pc_libpathhal=`pkg-config hal --libs-only-L 2>/dev/null`
1060 pc_verhal=`pkg-config hal --modversion 2>/dev/null`
1061 if [ ! -z "$pc_cflagshal" ]; then # is this acceptable?
1062 CFLAGSHAL=$pc_cflagshal
1063 LIBPATHHAL=$pc_libpathhal
1064 LIBHAL=$pc_libhal
1065 fi
1066 cat > .tmp_src.cc << EOF
1067#include <cstdio>
1068#include <libhal.h>
1069extern "C" int main(void)
1070{
1071 DBusError dbusError;
1072 dbus_error_init (&dbusError);
1073 LibHalContext *halContext = libhal_ctx_new();
1074 if (halContext != 0)
1075 {
1076 libhal_ctx_free(halContext);
1077 }
1078 return 0;
1079}
1080EOF
1081 if test_compile "$CFLAGSHAL $LIBPATHHAL $LIBHAL" libhal libhal; then
1082 log_success "found version $pc_verhal"
1083 cnf_append "LIB_HAL_CFLAGS" "$CFLAGSHAL"
1084 cnf_append "LIB_HAL_LIBS" "`strip_l "$LIBHAL"`"
1085 cnf_append "LIB_HAL_LIBPATH" "`strip_L "$LIBPATHHAL"`"
1086 cnf_append "VBOX_WITH_LIBHAL" "1"
1087 fi
1088}
1089
1090
1091#
1092# Show help
1093#
1094show_help()
1095{
1096 cat << EOF
1097Usage: ./configure [OPTIONS]...
1098
1099Configuration:
1100 -h, --help display this help and exit
1101 --nofatal don't abort on errors
1102 --disable-xpcom disable XPCOM and related stuff
1103 --disable-sdl-ttf disable SDL_ttf detection
1104 --build-xalan build xalan & xerces from shipped sources
1105 --without-hal do not use libhal, even if it is available
1106
1107Paths:
1108 --with-gcc=PATH location of the gcc compiler [$CC]
1109 --with-g++=PATH location of the g++ compiler [$CXX]
1110 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1111 --with-iasl=PATH location of the iasl compiler [$IASL]
1112 --with-hal-cflags=FLAGS cflags for libhal [$CFLAGSHAL]
1113 --with-hal=LIB location of the libhal libraries [$LIBHAL]
1114 --with-linux=DIR Linux kernel source directory [$LINUX]
1115 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1116 --with-qt-dir=DIR directory for QT headers/libraries [$QTDIR]
1117 --with-xalan=LIB location of the xalan library [$LIBXALAN]
1118 --with-xerces=LIB location of the xerces library [$LIBXERCES]
1119
1120Build type:
1121 -d, --build-debug build with debugging symbols and assertions
1122EOF
1123 exit 0
1124}
1125
1126
1127#
1128# The body.
1129#
1130
1131# scan command line options
1132for option; do
1133 case "$option" in
1134 --help|-help|-h)
1135 show_help
1136 ;;
1137 --nofatal)
1138 nofatal=1
1139 ;;
1140 --with-gcc=*)
1141 CC=`echo $option | cut -d'=' -f2`
1142 ;;
1143 --with-g++=*)
1144 CXX=`echo $option | cut -d'=' -f2`
1145 ;;
1146 --with-kbuild=*)
1147 KBUILDDIR=`echo $option | cut -d'=' -f2`
1148 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1149 echo "Error: KBUILDDIR contains invalid characters!"
1150 exit 1
1151 fi
1152 ;;
1153 --with-qt-dir=*)
1154 QTDIR=`echo $option | cut -d'=' -f2`
1155 ;;
1156 --with-hal-dir=*)
1157 INCHAL=`echo $option | cut -d'=' -f2`
1158 ;;
1159 --with-hal=*)
1160 LIBHAL=`echo $option | cut -d'=' -f2`
1161 ;;
1162 --with-iasl=*)
1163 IASL=`echo $option | cut -d'=' -f2`
1164 ;;
1165 --with-linux=*)
1166 LINUX=`echo $option | cut -d'=' -f2`
1167 ;;
1168 --with-mkisofs=*)
1169 MKISOFS=`echo $option | cut -d'=' -f2`
1170 ;;
1171 --with-xalan=*)
1172 LIBXALAN=`echo $option | cut -d'=' -f2`
1173 ;;
1174 --with-xerces=*)
1175 LIBXERCES=`echo $option | cut -d'=' -f2`
1176 ;;
1177 --disable-xpcom)
1178 WITH_XPCOM=0
1179 ;;
1180 --disable-sdl-ttf)
1181 WITH_SDL_TTF=0
1182 ;;
1183 --disable-qt)
1184 WITH_QT=0
1185 ;;
1186 --without-hal)
1187 WITH_HAL=0
1188 ;;
1189 --build-debug|-d)
1190 BUILD_TYPE=debug
1191 ;;
1192 --build-xalan)
1193 LIBXERCES=``
1194 LIBXALAN=``
1195 ;;
1196 --ose)
1197 OSE=2
1198 ;;
1199 --odir=*)
1200 ODIR=`echo $option | cut -d'=' -f2`
1201 ;;
1202 *)
1203 echo
1204 echo "Unrecognized option \"$option\""
1205 echo
1206 show_help
1207 ;;
1208 esac
1209done
1210
1211LOG="${ODIR:+$ODIR/}$LOG"
1212ENV="${ODIR:+$ODIR/}$ENV"
1213CNF="${ODIR:+$ODIR/}$CNF"
1214
1215# initialize output files
1216cat > $LOG << EOF
1217# Log file generated by
1218#
1219# '$0 $*'
1220#
1221
1222EOF
1223cat > $CNF << EOF
1224# -*- Makefile -*-
1225#
1226# automatically generated by
1227#
1228# '$0 $*'
1229#
1230# It will be completely overwritten if configure is executed again.
1231#
1232
1233EOF
1234cat > $ENV << EOF
1235#!/bin/bash
1236#
1237# automatically generated by
1238#
1239# '$0 $*'
1240#
1241# It will be completely overwritten if configure is executed again.
1242# Make sure you source this file once before you start to build VBox.
1243#
1244
1245EOF
1246
1247# test if we are OSE
1248if [ $OSE -eq 1 -a -d "`cd $(dirname $0); pwd`/src/VBox/Devices/USB" ]; then
1249 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1250 echo >> $LOG
1251 OSE=0
1252fi
1253
1254if [ "$BUILD_TYPE" = "debug" ]; then
1255 echo "Creating DEBUG build!" >> $LOG
1256fi
1257
1258# first determine our environment
1259check_environment
1260check_kbuild
1261
1262# some things are not available in for OSE
1263if [ $OSE -ge 1 ]; then
1264 cnf_append "VBOX_OSE" "1"
1265 cnf_append "VBOX_WITH_TESTSUITE" ""
1266 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
1267
1268 if [ "$OS" = "linux" ]; then
1269 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
1270 else
1271 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
1272 fi
1273 echo >> $CNF
1274fi
1275
1276# emit disable directives corresponding to any --disable-xxx options.
1277[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
1278[ $WITH_QT -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
1279[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
1280
1281# append the tools directory to the default search path
1282echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1283
1284# append some extra paths
1285PATH="$PATH:/opt/gnome/bin"
1286
1287# the tools
1288check_gcc
1289[ "$OS" != "darwin" ] && check_as86
1290[ "$OS" != "darwin" ] && check_bcc
1291[ "$OS" != "darwin" ] && check_iasl
1292# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
1293# [ "$OS" != "darwin" ] && check_yasm
1294[ "$OS" != "darwin" ] && check_xsltproc
1295[ $OSE -eq 0 ] && check_mkisofs
1296
1297# the libraries
1298[ "$OS" != "darwin" ] && check_pthread
1299[ $WITH_XPCOM -eq 1 ] && check_xalan
1300[ $WITH_XPCOM -eq 1 ] && check_xerces
1301[ $WITH_LIBIDL -eq 1 ] && check_libidl
1302[ $OSE -eq 0 ] && check_ssl
1303[ "$OS" != "darwin" ] && check_z
1304[ $OSE -eq 0 ] && check_png
1305[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
1306[ "$OS" != "darwin" ] && check_sdl
1307[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
1308[ "$OS" != "darwin" ] && check_x
1309[ "$OS" != "darwin" ] && check_xcursor
1310[ $WITH_QT -eq 1 ] && check_qt
1311
1312# Linux-specific
1313if [ "$OS" = "linux" ]; then
1314 check_linux
1315 check_alsa
1316 check_compiler_h
1317 [ "$WITH_HAL" = "1" ] && check_libhal
1318fi
1319
1320# success!
1321echo
1322echo "Successfully generated '$CNF' and '$ENV'."
1323echo "Source '$ENV' once before you start to build VBox:"
1324echo ""
1325echo " source $ENV"
1326echo " kmk"
1327echo ""
1328if [ "$OS" = "linux" ]; then
1329 echo "To compile the kernel module, do:"
1330 echo ""
1331 echo " cd ./out/$OS.$MACHINE/$BUILD_TYPE/bin/src"
1332 echo " make"
1333 echo ""
1334fi
1335echo "Enjoy!"
1336cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette